package com.rebusland.fin.derivatives.eq.server.input.model;

import org.joda.beans.ImmutableBean;
import org.joda.beans.gen.BeanDefinition;
import org.joda.beans.gen.PropertyDefinition;

import com.rebusland.fin.derivatives.eq.server.common.model.SerializableBeanFacade;
import com.rebusland.fin.derivatives.eq.server.enums.model.SimulationScheduler;
import com.rebusland.fin.derivatives.eq.server.enums.model.VarianceReduction;
import com.rebusland.fin.derivatives.eq.server.enums.model.VariateGenerator;

import java.util.Map;
import java.util.NoSuchElementException;
import org.joda.beans.Bean;
import org.joda.beans.JodaBeanUtils;
import org.joda.beans.MetaBean;
import org.joda.beans.MetaProperty;
import org.joda.beans.impl.direct.DirectFieldsBeanBuilder;
import org.joda.beans.impl.direct.DirectMetaBean;
import org.joda.beans.impl.direct.DirectMetaProperty;
import org.joda.beans.impl.direct.DirectMetaPropertyMap;

@BeanDefinition
public class MonteCarloSettings extends SerializableBeanFacade implements ImmutableBean {
	@PropertyDefinition(validate = "notNull")
	private final GreeksSettings greeks;

	@PropertyDefinition(validate = "notNull")
	private final VariateGenerator variateGenerator;

	@PropertyDefinition(validate = "notNull")
	private final Long seed;

	@PropertyDefinition(validate = "notNull")
	private final Integer nSimulations;

	@PropertyDefinition(validate = "notNull")
	private final SimulationScheduler simulationScheduler;

	@PropertyDefinition
	private final Integer nThreads;

	@PropertyDefinition
	private final VarianceReduction varianceReduction;

	//------------------------- AUTOGENERATED START -------------------------
	/**
	 * The meta-bean for {@code MonteCarloSettings}.
	 * @return the meta-bean, not null
	 */
	public static MonteCarloSettings.Meta meta() {
		return MonteCarloSettings.Meta.INSTANCE;
	}

	static {
		MetaBean.register(MonteCarloSettings.Meta.INSTANCE);
	}

	/**
	 * Returns a builder used to create an instance of the bean.
	 * @return the builder, not null
	 */
	public static MonteCarloSettings.Builder builder() {
		return new MonteCarloSettings.Builder();
	}

	/**
	 * Restricted constructor.
	 * @param builder  the builder to copy from, not null
	 */
	protected MonteCarloSettings(MonteCarloSettings.Builder builder) {
		JodaBeanUtils.notNull(builder.greeks, "greeks");
		JodaBeanUtils.notNull(builder.variateGenerator, "variateGenerator");
		JodaBeanUtils.notNull(builder.seed, "seed");
		JodaBeanUtils.notNull(builder.nSimulations, "nSimulations");
		JodaBeanUtils.notNull(builder.simulationScheduler, "simulationScheduler");
		this.greeks = builder.greeks;
		this.variateGenerator = builder.variateGenerator;
		this.seed = builder.seed;
		this.nSimulations = builder.nSimulations;
		this.simulationScheduler = builder.simulationScheduler;
		this.nThreads = builder.nThreads;
		this.varianceReduction = builder.varianceReduction;
	}

	@Override
	public MonteCarloSettings.Meta metaBean() {
		return MonteCarloSettings.Meta.INSTANCE;
	}

	//-----------------------------------------------------------------------
	/**
	 * Gets the greeks.
	 * @return the value of the property, not null
	 */
	public GreeksSettings getGreeks() {
		return greeks;
	}

	//-----------------------------------------------------------------------
	/**
	 * Gets the variateGenerator.
	 * @return the value of the property, not null
	 */
	public VariateGenerator getVariateGenerator() {
		return variateGenerator;
	}

	//-----------------------------------------------------------------------
	/**
	 * Gets the seed.
	 * @return the value of the property, not null
	 */
	public Long getSeed() {
		return seed;
	}

	//-----------------------------------------------------------------------
	/**
	 * Gets the nSimulations.
	 * @return the value of the property, not null
	 */
	public Integer getNSimulations() {
		return nSimulations;
	}

	//-----------------------------------------------------------------------
	/**
	 * Gets the simulationScheduler.
	 * @return the value of the property, not null
	 */
	public SimulationScheduler getSimulationScheduler() {
		return simulationScheduler;
	}

	//-----------------------------------------------------------------------
	/**
	 * Gets the nThreads.
	 * @return the value of the property
	 */
	public Integer getNThreads() {
		return nThreads;
	}

	//-----------------------------------------------------------------------
	/**
	 * Gets the varianceReduction.
	 * @return the value of the property
	 */
	public VarianceReduction getVarianceReduction() {
		return varianceReduction;
	}

	//-----------------------------------------------------------------------
	/**
	 * Returns a builder that allows this bean to be mutated.
	 * @return the mutable builder, not null
	 */
	public Builder toBuilder() {
		return new Builder(this);
	}

	@Override
	public boolean equals(Object obj) {
		if (obj == this) {
			return true;
		}
		if (obj != null && obj.getClass() == this.getClass()) {
			MonteCarloSettings other = (MonteCarloSettings) obj;
			return JodaBeanUtils.equal(greeks, other.greeks) &&
					JodaBeanUtils.equal(variateGenerator, other.variateGenerator) &&
					JodaBeanUtils.equal(seed, other.seed) &&
					JodaBeanUtils.equal(nSimulations, other.nSimulations) &&
					JodaBeanUtils.equal(simulationScheduler, other.simulationScheduler) &&
					JodaBeanUtils.equal(nThreads, other.nThreads) &&
					JodaBeanUtils.equal(varianceReduction, other.varianceReduction);
		}
		return false;
	}

	@Override
	public int hashCode() {
		int hash = getClass().hashCode();
		hash = hash * 31 + JodaBeanUtils.hashCode(greeks);
		hash = hash * 31 + JodaBeanUtils.hashCode(variateGenerator);
		hash = hash * 31 + JodaBeanUtils.hashCode(seed);
		hash = hash * 31 + JodaBeanUtils.hashCode(nSimulations);
		hash = hash * 31 + JodaBeanUtils.hashCode(simulationScheduler);
		hash = hash * 31 + JodaBeanUtils.hashCode(nThreads);
		hash = hash * 31 + JodaBeanUtils.hashCode(varianceReduction);
		return hash;
	}

	@Override
	public String toString() {
		StringBuilder buf = new StringBuilder(256);
		buf.append("MonteCarloSettings{");
		int len = buf.length();
		toString(buf);
		if (buf.length() > len) {
			buf.setLength(buf.length() - 2);
		}
		buf.append('}');
		return buf.toString();
	}

	protected void toString(StringBuilder buf) {
		buf.append("greeks").append('=').append(JodaBeanUtils.toString(greeks)).append(',').append(' ');
		buf.append("variateGenerator").append('=').append(JodaBeanUtils.toString(variateGenerator)).append(',').append(' ');
		buf.append("seed").append('=').append(JodaBeanUtils.toString(seed)).append(',').append(' ');
		buf.append("nSimulations").append('=').append(JodaBeanUtils.toString(nSimulations)).append(',').append(' ');
		buf.append("simulationScheduler").append('=').append(JodaBeanUtils.toString(simulationScheduler)).append(',').append(' ');
		buf.append("nThreads").append('=').append(JodaBeanUtils.toString(nThreads)).append(',').append(' ');
		buf.append("varianceReduction").append('=').append(JodaBeanUtils.toString(varianceReduction)).append(',').append(' ');
	}

	//-----------------------------------------------------------------------
	/**
	 * The meta-bean for {@code MonteCarloSettings}.
	 */
	public static class Meta extends DirectMetaBean {
		/**
		 * The singleton instance of the meta-bean.
		 */
		static final Meta INSTANCE = new Meta();

		/**
		 * The meta-property for the {@code greeks} property.
		 */
		private final MetaProperty<GreeksSettings> greeks = DirectMetaProperty.ofImmutable(
				this, "greeks", MonteCarloSettings.class, GreeksSettings.class);
		/**
		 * The meta-property for the {@code variateGenerator} property.
		 */
		private final MetaProperty<VariateGenerator> variateGenerator = DirectMetaProperty.ofImmutable(
				this, "variateGenerator", MonteCarloSettings.class, VariateGenerator.class);
		/**
		 * The meta-property for the {@code seed} property.
		 */
		private final MetaProperty<Long> seed = DirectMetaProperty.ofImmutable(
				this, "seed", MonteCarloSettings.class, Long.class);
		/**
		 * The meta-property for the {@code nSimulations} property.
		 */
		private final MetaProperty<Integer> nSimulations = DirectMetaProperty.ofImmutable(
				this, "nSimulations", MonteCarloSettings.class, Integer.class);
		/**
		 * The meta-property for the {@code simulationScheduler} property.
		 */
		private final MetaProperty<SimulationScheduler> simulationScheduler = DirectMetaProperty.ofImmutable(
				this, "simulationScheduler", MonteCarloSettings.class, SimulationScheduler.class);
		/**
		 * The meta-property for the {@code nThreads} property.
		 */
		private final MetaProperty<Integer> nThreads = DirectMetaProperty.ofImmutable(
				this, "nThreads", MonteCarloSettings.class, Integer.class);
		/**
		 * The meta-property for the {@code varianceReduction} property.
		 */
		private final MetaProperty<VarianceReduction> varianceReduction = DirectMetaProperty.ofImmutable(
				this, "varianceReduction", MonteCarloSettings.class, VarianceReduction.class);
		/**
		 * The meta-properties.
		 */
		private final Map<String, MetaProperty<?>> metaPropertyMap$ = new DirectMetaPropertyMap(
				this, null,
				"greeks",
				"variateGenerator",
				"seed",
				"nSimulations",
				"simulationScheduler",
				"nThreads",
				"varianceReduction");

		/**
		 * Restricted constructor.
		 */
		protected Meta() {
		}

		@Override
		protected MetaProperty<?> metaPropertyGet(String propertyName) {
			switch (propertyName.hashCode()) {
				case -1237773965:  // greeks
					return greeks;
				case -1185415293:  // variateGenerator
					return variateGenerator;
				case 3526257:  // seed
					return seed;
				case 1591890430:  // nSimulations
					return nSimulations;
				case 550081140:  // simulationScheduler
					return simulationScheduler;
				case -1237675173:  // nThreads
					return nThreads;
				case -492469502:  // varianceReduction
					return varianceReduction;
			}
			return super.metaPropertyGet(propertyName);
		}

		@Override
		public MonteCarloSettings.Builder builder() {
			return new MonteCarloSettings.Builder();
		}

		@Override
		public Class<? extends MonteCarloSettings> beanType() {
			return MonteCarloSettings.class;
		}

		@Override
		public Map<String, MetaProperty<?>> metaPropertyMap() {
			return metaPropertyMap$;
		}

		//-----------------------------------------------------------------------
		/**
		 * The meta-property for the {@code greeks} property.
		 * @return the meta-property, not null
		 */
		public final MetaProperty<GreeksSettings> greeks() {
			return greeks;
		}

		/**
		 * The meta-property for the {@code variateGenerator} property.
		 * @return the meta-property, not null
		 */
		public final MetaProperty<VariateGenerator> variateGenerator() {
			return variateGenerator;
		}

		/**
		 * The meta-property for the {@code seed} property.
		 * @return the meta-property, not null
		 */
		public final MetaProperty<Long> seed() {
			return seed;
		}

		/**
		 * The meta-property for the {@code nSimulations} property.
		 * @return the meta-property, not null
		 */
		public final MetaProperty<Integer> nSimulations() {
			return nSimulations;
		}

		/**
		 * The meta-property for the {@code simulationScheduler} property.
		 * @return the meta-property, not null
		 */
		public final MetaProperty<SimulationScheduler> simulationScheduler() {
			return simulationScheduler;
		}

		/**
		 * The meta-property for the {@code nThreads} property.
		 * @return the meta-property, not null
		 */
		public final MetaProperty<Integer> nThreads() {
			return nThreads;
		}

		/**
		 * The meta-property for the {@code varianceReduction} property.
		 * @return the meta-property, not null
		 */
		public final MetaProperty<VarianceReduction> varianceReduction() {
			return varianceReduction;
		}

		//-----------------------------------------------------------------------
		@Override
		protected Object propertyGet(Bean bean, String propertyName, boolean quiet) {
			switch (propertyName.hashCode()) {
				case -1237773965:  // greeks
					return ((MonteCarloSettings) bean).getGreeks();
				case -1185415293:  // variateGenerator
					return ((MonteCarloSettings) bean).getVariateGenerator();
				case 3526257:  // seed
					return ((MonteCarloSettings) bean).getSeed();
				case 1591890430:  // nSimulations
					return ((MonteCarloSettings) bean).getNSimulations();
				case 550081140:  // simulationScheduler
					return ((MonteCarloSettings) bean).getSimulationScheduler();
				case -1237675173:  // nThreads
					return ((MonteCarloSettings) bean).getNThreads();
				case -492469502:  // varianceReduction
					return ((MonteCarloSettings) bean).getVarianceReduction();
			}
			return super.propertyGet(bean, propertyName, quiet);
		}

		@Override
		protected void propertySet(Bean bean, String propertyName, Object newValue, boolean quiet) {
			metaProperty(propertyName);
			if (quiet) {
				return;
			}
			throw new UnsupportedOperationException("Property cannot be written: " + propertyName);
		}

	}

	//-----------------------------------------------------------------------
	/**
	 * The bean-builder for {@code MonteCarloSettings}.
	 */
	public static class Builder extends DirectFieldsBeanBuilder<MonteCarloSettings> {

		private GreeksSettings greeks;
		private VariateGenerator variateGenerator;
		private Long seed;
		private Integer nSimulations;
		private SimulationScheduler simulationScheduler;
		private Integer nThreads;
		private VarianceReduction varianceReduction;

		/**
		 * Restricted constructor.
		 */
		protected Builder() {
		}

		/**
		 * Restricted copy constructor.
		 * @param beanToCopy  the bean to copy from, not null
		 */
		protected Builder(MonteCarloSettings beanToCopy) {
			this.greeks = beanToCopy.getGreeks();
			this.variateGenerator = beanToCopy.getVariateGenerator();
			this.seed = beanToCopy.getSeed();
			this.nSimulations = beanToCopy.getNSimulations();
			this.simulationScheduler = beanToCopy.getSimulationScheduler();
			this.nThreads = beanToCopy.getNThreads();
			this.varianceReduction = beanToCopy.getVarianceReduction();
		}

		//-----------------------------------------------------------------------
		@Override
		public Object get(String propertyName) {
			switch (propertyName.hashCode()) {
				case -1237773965:  // greeks
					return greeks;
				case -1185415293:  // variateGenerator
					return variateGenerator;
				case 3526257:  // seed
					return seed;
				case 1591890430:  // nSimulations
					return nSimulations;
				case 550081140:  // simulationScheduler
					return simulationScheduler;
				case -1237675173:  // nThreads
					return nThreads;
				case -492469502:  // varianceReduction
					return varianceReduction;
				default:
					throw new NoSuchElementException("Unknown property: " + propertyName);
			}
		}

		@Override
		public Builder set(String propertyName, Object newValue) {
			switch (propertyName.hashCode()) {
				case -1237773965:  // greeks
					this.greeks = (GreeksSettings) newValue;
					break;
				case -1185415293:  // variateGenerator
					this.variateGenerator = (VariateGenerator) newValue;
					break;
				case 3526257:  // seed
					this.seed = (Long) newValue;
					break;
				case 1591890430:  // nSimulations
					this.nSimulations = (Integer) newValue;
					break;
				case 550081140:  // simulationScheduler
					this.simulationScheduler = (SimulationScheduler) newValue;
					break;
				case -1237675173:  // nThreads
					this.nThreads = (Integer) newValue;
					break;
				case -492469502:  // varianceReduction
					this.varianceReduction = (VarianceReduction) newValue;
					break;
				default:
					throw new NoSuchElementException("Unknown property: " + propertyName);
			}
			return this;
		}

		@Override
		public Builder set(MetaProperty<?> property, Object value) {
			super.set(property, value);
			return this;
		}

		@Override
		public MonteCarloSettings build() {
			return new MonteCarloSettings(this);
		}

		//-----------------------------------------------------------------------
		/**
		 * Sets the greeks.
		 * @param greeks  the new value, not null
		 * @return this, for chaining, not null
		 */
		public Builder greeks(GreeksSettings greeks) {
			JodaBeanUtils.notNull(greeks, "greeks");
			this.greeks = greeks;
			return this;
		}

		/**
		 * Sets the variateGenerator.
		 * @param variateGenerator  the new value, not null
		 * @return this, for chaining, not null
		 */
		public Builder variateGenerator(VariateGenerator variateGenerator) {
			JodaBeanUtils.notNull(variateGenerator, "variateGenerator");
			this.variateGenerator = variateGenerator;
			return this;
		}

		/**
		 * Sets the seed.
		 * @param seed  the new value, not null
		 * @return this, for chaining, not null
		 */
		public Builder seed(Long seed) {
			JodaBeanUtils.notNull(seed, "seed");
			this.seed = seed;
			return this;
		}

		/**
		 * Sets the nSimulations.
		 * @param nSimulations  the new value, not null
		 * @return this, for chaining, not null
		 */
		public Builder nSimulations(Integer nSimulations) {
			JodaBeanUtils.notNull(nSimulations, "nSimulations");
			this.nSimulations = nSimulations;
			return this;
		}

		/**
		 * Sets the simulationScheduler.
		 * @param simulationScheduler  the new value, not null
		 * @return this, for chaining, not null
		 */
		public Builder simulationScheduler(SimulationScheduler simulationScheduler) {
			JodaBeanUtils.notNull(simulationScheduler, "simulationScheduler");
			this.simulationScheduler = simulationScheduler;
			return this;
		}

		/**
		 * Sets the nThreads.
		 * @param nThreads  the new value
		 * @return this, for chaining, not null
		 */
		public Builder nThreads(Integer nThreads) {
			this.nThreads = nThreads;
			return this;
		}

		/**
		 * Sets the varianceReduction.
		 * @param varianceReduction  the new value
		 * @return this, for chaining, not null
		 */
		public Builder varianceReduction(VarianceReduction varianceReduction) {
			this.varianceReduction = varianceReduction;
			return this;
		}

		//-----------------------------------------------------------------------
		@Override
		public String toString() {
			StringBuilder buf = new StringBuilder(256);
			buf.append("MonteCarloSettings.Builder{");
			int len = buf.length();
			toString(buf);
			if (buf.length() > len) {
				buf.setLength(buf.length() - 2);
			}
			buf.append('}');
			return buf.toString();
		}

		protected void toString(StringBuilder buf) {
			buf.append("greeks").append('=').append(JodaBeanUtils.toString(greeks)).append(',').append(' ');
			buf.append("variateGenerator").append('=').append(JodaBeanUtils.toString(variateGenerator)).append(',').append(' ');
			buf.append("seed").append('=').append(JodaBeanUtils.toString(seed)).append(',').append(' ');
			buf.append("nSimulations").append('=').append(JodaBeanUtils.toString(nSimulations)).append(',').append(' ');
			buf.append("simulationScheduler").append('=').append(JodaBeanUtils.toString(simulationScheduler)).append(',').append(' ');
			buf.append("nThreads").append('=').append(JodaBeanUtils.toString(nThreads)).append(',').append(' ');
			buf.append("varianceReduction").append('=').append(JodaBeanUtils.toString(varianceReduction)).append(',').append(' ');
		}

	}

	//-------------------------- AUTOGENERATED END --------------------------
}
